//
// C++ Interface: QFSqlCatalog
//
// Description:
//
//
// Author: Fanda Vacek <fanda.vacek@volny.cz>, (C) 2005
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef QFSQLCATALOG_H
#define QFSQLCATALOG_H

#include <qfcoreglobal.h>
#include <qf.h>
#include <qfsql.h>
#include <qfsqlfield.h>
#include <qfassert.h>
//#include <qfexplicitlyshareddata.h>
#include <qfsqlconnectionbase.h>

#include <QSqlIndex>
#include <QStringList>
#include <QCoreApplication>

class QFSqlTableInfo;
class QFSqlDbInfo;
class QFSqlCatalog;
class QFSqlConnection;
class QSqlDriver;

//! extended field info for catalog fields
class QFCORE_DECL_EXPORT QFSqlFieldInfo : public QFSqlField
{
	//friend class QFSqlDbInfo;
	protected:
		struct Data : public QSharedData
		{
			QFSqlCatalog *catalog;
			QString fulltablename;
			QString seqname;
			quint8 nullable:1;
			quint8 isunsigned:1;
			quint8 autoincrement:1;
			QString characterSet;
			QString comment;
			QVariantMap nativeValues;
			Data(QFSqlCatalog *cat, const QString& full_tbl_name)
				: catalog(cat), fulltablename(full_tbl_name), nullable(true), isunsigned(false), autoincrement(false) {}
		};
	private:
		/// pozor i sharedNull() je explicitly sdilenej, vsechno, co se do nej ulozi, maji vsechny jeho reference.
		QExplicitlySharedDataPointer<Data> d;
	protected:
		QFSqlCatalog* catalog() throw(QFSqlException)
		{
			if(!d->catalog) QF_SQL_EXCEPTION("catalog is NULL");
			return d->catalog;
		}
	public:
		//! \a fullName always starts with '.'
		QString fullName() const {return d->fulltablename + '.' + name();}
		bool isValid() const {return d->catalog;}
		QString seqName() const {return d->seqname;} //!< name of sequence, if field is autogenerated
		void setSeqName(const QString &n) {d->seqname = n;}
		const QVariantMap& nativeValues() const {return d->nativeValues;}
		QVariant nativeValue(const QString &key) const {return nativeValues().value(key);}
		QVariantMap& nativeValuesRef() {return d->nativeValues;}
		QStringList enumOrSetFields() const {return nativeValue("enumOrSetFields").toStringList();}
		QString nativeType() const {return d->nativeValues.value("nativeType").toString();}
		void setNativeType(const QString &s) {d->nativeValues["nativeType"] = s;}
		QString characterSet() const {return d->characterSet;}
		void setCharacterSet(const QString &s) {d->characterSet = s;}
		QString comment() const {return d->comment;}
		void setComment(const QString &s) {d->comment = s;}
		bool isNullable() const {return d->nullable;}
		void setNullable(bool b) {d->nullable = b;}
		bool isUnsigned() const {return d->isunsigned;}
		void setUnsigned(bool b) {d->isunsigned = b;}
		bool isAutoIncrement() const {return d->autoincrement;}
		void setAutoIncrement(bool b) {d->autoincrement = b;}
		QVariant seqNextVal() throw(QFSqlException);
		/*
		const QFSqlTableInfo& table() const throw(QFSqlException)
		{
			if(!d->tableinfo) QF_SQL_EXCEPTION("tableinfo is NULL");
			return *(d->tableinfo);
		}
		*/
		QString toString(const QString &indent = QString()) const;
	protected:
		static const QFSqlFieldInfo& sharedNull();
		QFSqlFieldInfo(int)
		{
			d = new Data(NULL, QString());
		}
	public:
		QFSqlFieldInfo()
			: QFSqlField()
		{
			*this = sharedNull();
		}
		QFSqlFieldInfo(QFSqlCatalog *cat, const QString& full_tbl_name = QString())
			: QFSqlField()
		{
			d = new Data(cat, full_tbl_name);
		}
		QFSqlFieldInfo(const QFSqlField &other, QFSqlCatalog *cat = NULL, const QString& full_tbl_name = QString())
			: QFSqlField(other)
		{
			d = new Data(cat, full_tbl_name);
		}
};

/**
 * cashed information about SQL table structure.
 */
class QFCORE_DECL_EXPORT QFSqlTableInfo
{
	Q_DECLARE_TR_FUNCTIONS(QFSqlTableInfo);
	friend class QFSqlFieldInfo;
	friend class QFSqlDbInfo;
	public:
		typedef QMap<QString, QFSqlFieldInfo> FieldMap;
	protected:
		struct Data : public QSharedData
		{
			QFSql::RelationKind kind;
			//const QFSqlDbInfo *dbinfo; // parent
			QFSqlCatalog *catalog;
			QString fullname;
			QSqlIndex prikeys;
			FieldMap fields;
			QFSqlConnectionBase::IndexList indexes;
			QStringList unorderedFieldNames; //!< sometimes it is needed to know in which order are fields on SQL server (QMap resort fields by their names)
			bool loaded;
			bool fieldsUpToDate; /// pri volani funkce fields() se pouzije cache

			Data(QFSqlCatalog *cat, const QString &full_name, QFSql::RelationKind rel_kind)
				: kind(rel_kind), catalog(cat), fullname(full_name), loaded(false), fieldsUpToDate(false) {}
		};
	private:
		/// pozor i sharedNull() je explicitly sdilenej, vsechno, co se do nej ulozi, maji vsechny jeho reference.
		QExplicitlySharedDataPointer<Data> d;
	protected:
		bool fieldsUpToDate() const {return d->fieldsUpToDate;}
		bool infoLoaded() const {return d->loaded;}
		void setInfoLoaded(bool v = true) {d->loaded = v;}
		QFSqlCatalog* catalog() throw(QFSqlException)
		{
			if(!d->catalog) QF_SQL_EXCEPTION("catalog is NULL");
			return d->catalog;
		}
	public:
		bool isValid() const {return d->catalog;}

		/// return kind of table (View or Table).
 		/// \sa QFSqlTableInfo::Kind
		QFSql::RelationKind relationKind() const {return d->kind;}
		QString kindAsString() const;
		/// @return .database.table or .schema.table (PSQL)
		/// \a fullName always starts with '.'
		QString fullName() const {return d->fullname;}
		QString tableName() const;
		QString dbName() const;
	protected:
		QFSqlFieldInfo* fieldRef(const QString &fieldname, bool throw_exc = Qf::ThrowExc/*, bool do_not_reload_fields = false*/)  throw(QFSqlException);
	public:
		/**
		 * retrieves field definition from cash or loads it from server, if it is not cashed
		 * @return reference to field definition
		 */
		QFSqlFieldInfo field(const QString &fieldname, bool throw_exc = Qf::ThrowExc) const  throw(QFSqlException)
		{
			QFSqlFieldInfo *ref = ((QFSqlTableInfo*)this)->fieldRef(fieldname, throw_exc);
			if(ref) return *ref;
			if(throw_exc) QF_SQL_EXCEPTION(tr("Field '%1' not found").arg(fieldname));
			return QFSqlFieldInfo();
		}
		/**
		 *  Return list of fields in table \a tablename in alfabet order
		 */
		QStringList fields(bool reload = false)  throw(QFSqlException);
		/**
		 *  Return list of fields in table \a tablename in order as they are in SQL server table.
		 */
		QStringList unorderedFields() {fields(); return d->unorderedFieldNames;}
		const QFSqlConnectionBase::IndexList& indexes();
		/**
		 * Overloaded function. Uses internal cash, so it query
		 * server only first time it is called.
		 * @see QSqlDatabse::primaryIndex()
		 */
		QSqlIndex primaryIndex() const {return d->prikeys;}

		/**
		 * if driver suport sequences and field is autogenerated, function finds next value for this field.
		 * Returns invalid variant in other case.
		 */
		QVariant seqNextVal(const QString &fldname) throw(QFSqlException);

		/**
		 * Clear all cashed information about fields
		 */
		void forgetFields();

		QString toString(const QString &indent = QString()) const;
	protected:
		static const QFSqlTableInfo& sharedNull();
		QFSqlTableInfo(int)
		{
			d = new Data(NULL, QString(), QFSql::UnknownRelation);
		}
	public:
		QFSqlTableInfo()
		{
			*this = sharedNull();
		}
		QFSqlTableInfo(QFSqlCatalog *cat, const QString& full_name = QString(), QFSql::RelationKind rel_kind = QFSql::UnknownRelation);
};

/**
 * Explicitly shared cashed information about SQL database or schema structure.
 */
class QFCORE_DECL_EXPORT QFSqlDbInfo
{
	Q_DECLARE_TR_FUNCTIONS(QFSqlDbInfo);
	friend class QFSqlFieldInfo;
	friend class QFSqlTableInfo;
	protected:
		typedef QMap<QString, QFSqlTableInfo> TableMap;
		typedef QMapIterator<QString, QFSqlTableInfo> TableMapIterator;
	protected:
		struct Data : public QSharedData
		{
			QString fullname;
			TableMap tables;
			QFSqlCatalog *catalog;
			Data(QFSqlCatalog *cat, const QString& full_name) : fullname(full_name), catalog(cat), tablesUpToDate(false) {}
			bool tablesUpToDate;
		};
	private:
		QExplicitlySharedDataPointer<Data> d;
	public:
		void touchTables() {d->tablesUpToDate = false;}
	protected:
		bool tablesUpToDate() const {return d->tablesUpToDate;}
		QFSqlCatalog* catalog() throw(QFSqlException)
		{
			if(!d->catalog) QF_SQL_EXCEPTION("catalog is NULL");
			return d->catalog;
		}
		//QFSqlConnection connection() const throw(QFSqlException) {return catalog().connection();}
		// QFSqlDbInfo is implicitly shared, so any new structural information loaded from SQL server
		// should be written back to catalog.
		//void updateCatalog();
	protected:
		QFSqlTableInfo* tableRef(const QString& tblname, bool throw_exc = Qf::ThrowExc) throw(QFSqlException);
	public:
		bool isValid() const {return d->catalog != NULL;}
		/// \a fullName always starts with '.'
		QString fullName() const {return d->fullname;}
		QString dbName() const {return fullName();}
		QStringList tables(int relation_kinds = QFSql::AllRelations) throw(QFSqlException);
		QFSqlTableInfo table(const QString& tblname, bool throw_exc = Qf::ThrowExc) throw(QFSqlException);
		void forgetTable(const QString& name);

		QString toString(const QString &indent = QString()) const;
	protected:
		static const QFSqlDbInfo& sharedNull();
		QFSqlDbInfo(int)
		{
			d = new Data(NULL, QString());
		}
	public:
		QFSqlDbInfo()
		{
			*this = sharedNull();
		}
		QFSqlDbInfo(QFSqlCatalog *cat, const QString& full_name = QString::null);
		~QFSqlDbInfo() {}
};

/**
Cashed info about SQL server data structures.
Existuje staticka mapa katalogu. Klice jsou signatury QFSqlConnections.
Kazdy QFSqlCatalog obsahuje QFSqlConnection, pres ktere ziskava informace do sve cache.
NOT SHARED !
*/
class QFCORE_DECL_EXPORT QFSqlCatalog
{
	friend class QFSqlTableInfo;
	friend class QFSqlDbInfo;
	friend class QFSqlConnection;
	friend class QFSqlFieldInfo;
	protected:
		//typedef QMap<QString, QFSqlCatalog> CatalogMap;
		//static CatalogMap &catalogMap();
	public:
		//static QFSqlCatalog& catalogRef(const QString& connection_signature) throw(QFSqlException);
	protected:
		typedef QMap<QString, QFSqlDbInfo> DbMap;
		struct Data //: public QSharedData
		{
			QFSqlConnectionBase connection;
			DbMap databases;
			QString currentSchema;
			bool databasesUpToDate;
			QStringList serverVersion;
			Data(const QFSqlConnectionBase &con) : connection(con), databasesUpToDate(false) {}
		};
	private:
		Data _d, *d; // katalog nemuze byt shared, abych na nej moh mit pointer v infech
		//QSharedDataPointer<CatalogData> d;
	public:
		/// pokud db_name neni zadano je to defaultni database
		void touchTables(const QString &db_name = QString());
		void touchDatabases() {d->databasesUpToDate = false;}
	protected:
		bool databasesUpToDate() const {return d->databasesUpToDate;}
		QFSqlDbInfo* databaseRef(const QString& dbname, bool throw_exc = Qf::ThrowExc) throw(QFSqlException);
	protected:
		QFSqlConnectionBase connection() const {return d->connection;}
	protected:
		//void setDriver(QSqlDriver *drv) {d.driver = drv;}
	public:
		QStringList databases() throw(QFSqlException);
		/// pokud db_name neni zadano je to defaultni database
		QFSqlDbInfo database(const QString& dbname = QString(), bool throw_exc = Qf::ThrowExc) throw(QFSqlException);
		QFSqlTableInfo table(const QString& full_table_name, bool throw_exc = Qf::ThrowExc) throw(QFSqlException);

		void forgetTable(const QString& full_name);
		/// clear cashed info for database/schema \a dbname.
		void forgetDatabase(const QString& dbname);
		/// clear cash.
		void forgetAll();

		QString currentSchema() const;
		void setCurrentSchema(const QString &schema_name) throw(QFSqlException);
		
		QStringList serverVersion() const;
		int serverVersionMajor() const;

		QString toString(const QString &indent = QString()) const;
	private:
		//! disable copy, catalog is not shared.
		QFSqlCatalog& operator=(const QFSqlCatalog&);
	protected:
		QFSqlCatalog(const QFSqlConnectionBase &con);
	public:
		~QFSqlCatalog();
};

#endif // QFSQLCATALOG_H
